
 Подключаем библиотеки                                  
#include Wire.h                                            Подключаем библиотеку для работы с аппаратной шиной I2C.
#include iarduino_I2C_Motor.h                               Подключаем библиотеку для работы с мотором I2C-flash.
#include iarduino_I2C_Bumper.h                              Подключаем библиотеку для работы с бампером I2C-flash.
                                                           
 Создаём объекты                                        
iarduino_I2C_Motor   mot[2]={0x09,0x08};                      Объявляем массив mot состоящий из двух объектов для работы с моторами I2C-flash, указав адреса модулей моторов на шине I2C (0x0A-левый, 0x0B-правый).
iarduino_I2C_Bumper  bum    (0x0C);                           Объявляем объект bum для работы с бампером I2C-flash, указав адрес модуля на шине I2C.            
 Определяем константы                                   
const float    val_Radius   = 35.0f;                          Радиуса колеса в мм.
const float    val_Speed    = 20.0f;  
const float    val_Speed1    = val_Speed  0.99f;    Скорость движения машины в мсек.
const float    pid_KP       = val_Speed  0.23f;              Коэффициент пропорциональной обратной связи ПИД регулятора.
const float    pid_KI       = val_Speed  0;             Коэффициент интегральной     обратной связи ПИД регулятора.
const float    pid_KD       = val_Speed  0.8;              Коэффициент дифференциальной обратной связи ПИД регулятора.
                                                           
 Объявляем переменные                                   
float          arr_ERR[10]  = {0,0,0,0,0,0,0,0,0,0};          Массив последних ошибок для формирования интегральной составляющей ПИД регулятора.
uint8_t        i, j;                                          Переменные для работы с массивом последних ошибок.
                                                           
void setup(){                                              
     delay(1500);                                             Ждём завершение переходных процессов связанных с подачей питания.
   ИНИЦИАЛИЗАЦИЯ МОДУЛЕЙ                                
     mot[0].begin();                                          Инициируем работу с левым  мотором I2C-flash.
     mot[1].begin();                                          Инициируем работу с правым мотором I2C-flash.
     bum.   begin();                                          Инициируем работу с бампером I2C-flash.
     
   НАСТРОЙКА МОДУЛЕЙ                                    
     mot[0].radius = val_Radius;                              Указываем радиус колеса левого  мотора в мм.
     mot[1].radius = val_Radius;                              Указываем радиус колеса правого мотора в мм.
     mot[0].setDirection(false);                              Указываем левому  мотору, что его вращение должно быть обратным (против часовой стрелки при положительных скоростях).
     mot[1].setDirection(true);                               Указываем правому мотору, что его вращение должно быть прямым   (    по часовой стрелке при положительных скоростях).
     mot[0].setStopNeutral(false);                            Указываем не освобождать ротор левого  мотора при его остановке (если указать true, то ротор остановленного мотора можно вращать).
     mot[1].setStopNeutral(false);                            Указываем не освобождать ротор правого мотора при его остановке (если указать true, то ротор остановленного мотора можно вращать).
     bum.setTurnPeriod(BUM_TURN_200);                         Задать период мигания поворотников равен 800 мс.
     bum.setTurnSignal(BUM_TURN_AUTO);                        Работа поворотников в автоматическом режиме
     bum.settingsTurnAuto(BUM_AUTO_ON_2, BUM_AUTO_OFF_ANY, false);  поворотники работают в автоматическом режиме.
}                                                          
                                                           
void loop(){                                               

  
   
                                        Если датчик не фиксирует линии, ничего не делаем

  
     if(bum.getLineSum()  7)
     {
        mot[0].setSpeed(val_Speed, MOT_M_S);
        mot[1].setSpeed(val_Speed1, MOT_M_S);
     }
     
     else{
     i++; i%=10; j=10;                                        Определяем значения переменных работы с массивом ошибок.
                                                              Получаем текущую ошибку центрирования линии  
     arr_ERR[i] = bum.getErrPID();                            Функция getErrPID() возвращает ошибку от 0 до ±4.5, где 0 - линия по центру, ±4.0 - линия на крайнем датчике, ±4.5 - линия потеряна.
     if (bum.getCross(5, 100))
              arr_ERR[i] = bum.getSidePID(1);                            Функция getErrPID() возвращает ошибку от 0 до ±4.5, где 0 - линия по центру, ±4.0 - линия на крайнем датчике, ±4.5 - линия потеряна.
   Вычисляем все составляющие ПИД регулятора
     float pid_P = arr_ERR[i];                                Пропорциональная составляющая «pid_P» представлена величиной текущей ошибки «ARR_ERR[i]».
     float pid_I = 0.0f; while(j--){pid_I+=arr_ERR[j-1];}     Интегральная     составляющая «pid_I» представлена суммой последних ошибок взятых из массива «arr_ERR».
     float pid_D = arr_ERR[i]-arr_ERR[(i+9)%10];              Дифференциальная составляющая «pid_D» представлена разницей между текущей «ARR_ERR[i]» и предыдущей «arr_ERR[(i+9)%10]» ошибкой.
     float PID   = pid_Ppid_KP+pid_Ipid_KI+pid_Dpid_KD;    Вычисляем результат ПИД регулирования.
                                                              Устанавливаем скорость вращения колёс              
     mot[0].setSpeed( (val_Speed + PID) , MOT_M_S );            Устанавливаем скорость левого  мотора в мсек.
     mot[1].setSpeed( (val_Speed1 - PID), MOT_M_S );            Устанавливаем скорость правого мотора в мсек.
     
}         }         